chiark / gitweb /
git-debrebase: test suite: t-gdr-good: split up the big case into two (nfc)
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 cwd: $PWD
16 funcs: ${FUNCNAME[*]}
17 lines: ${BASH_LINENO[*]}
18 files: ${BASH_SOURCE[*]}
19 END
20         exit 16
21 }
22
23 trap 'test $? = 0 || t-report-failure' EXIT
24
25 t-filter-out-git-hyphen-dir
26
27 t-set-intree
28
29 : ${DGIT_TEST_DEBUG=-D}
30 export DGIT_TEST_DEBUG
31
32 : ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
33
34 export GIT_COMMITTER_DATE='1440253867 +0100'
35 export GIT_AUTHOR_DATE='1440253867 +0100'
36
37 root=`pwd`
38 troot=$root/tests
39 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
40 export DGIT_TEST_TROOT=$troot
41
42 tmp=$ADTTMP
43 if [ x"$tmp" = x ]; then
44         mkdir -p tests/tmp
45         tmpbase=$troot/tmp
46         tmp=tests/tmp/$testname
47         rm -rf $tmp
48         mkdir $tmp
49 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
50         tmpbase="$DGIT_TEST_TMPBASE"
51 fi
52 cd $tmp
53
54 tmp=`pwd`
55
56 t-set-using-tmp
57
58 test -f $tmp/.save-env || \
59 env -0 >$tmp/.save-env
60
61 ln -f $troot/ssh ssh
62
63 export DEBCHANGE_VENDOR=dpkg
64
65 mkdir -p $tmp/incoming
66 cat <<END >$tmp/dput.cf
67 [test-dummy]
68 method                  = local
69 incoming                = $tmp/incoming
70 run_dinstall            = 0
71 END
72
73 : ${t_archive_method:=aq}
74 : ${tagpfx:=archive/test-dummy}
75 : ${suitespecs:=sid:unstable}
76
77 t-git-next-date () {
78         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
79         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
80 }
81
82 t-expect-fail () {
83         local mpat="$1"; shift
84
85         set +o pipefail
86         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
87         local ps="${PIPESTATUS[*]}"
88         set -o pipefail
89
90         case $ps in
91         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
92         *" 0")  ;;
93         *)      fail "tee failed"  ;;
94         esac
95
96         t-grep-mpat "$mpat" $tmp/t.output
97 }
98
99 t-grep-mpat () {
100         local mpat="$1"
101         local file="$2"
102
103         local grepper=fgrep
104         case "$mpat" in
105         [A-Z]:*)
106                 case "$mpat" in
107                 E:*)    grepper=egrep   ;;
108                 F:*)    grepper=fgrep   ;;
109                 *)      fail "bad mpat prefix in $mpat";;
110                 esac
111                 mpat=${mpat#[A-Z]:}
112                 ;;
113         esac
114
115         $grepper -e "$mpat" "$file" ||
116                 fail "message not found"
117 }
118
119 t-expect-push-fail () {
120         local mpat="$1"; shift
121
122         local triedpush; triedpush=`git rev-parse HEAD`
123
124         t-reporefs pre-push
125         t-expect-fail "$mpat"  "$@"
126         t-reporefs post-push
127         diff $tmp/show-refs.{pre,post}-push
128
129         t-git-objects-not-present '' $triedpush
130
131         eval "$t_expect_push_fail_hook"
132 }
133
134 t-git-objects-not-present () {
135         # t-git-objects-not-present GITDIR|'' OBJID [...]
136         # specifying '' means the repo for package $p
137         local gitdir="${1-$dgitrepo}"
138         local obj
139         if ! [ -e "$gitdir" ]; then return; fi
140         for obj in "$@"; do
141                 GIT_DIR=$gitdir \
142                 t-expect-fail 'unable to find' \
143                 git cat-file -t $obj
144         done
145 }
146
147 t-reporefs () {
148         local whichoutput=$1; shift
149         local whichrepo=${1-$dgitrepo}
150         local outputfile="$tmp/show-refs.$whichoutput"
151         (set -e
152          exec >"$outputfile"
153          if test -d $whichrepo; then
154                 cd $whichrepo
155                 git show-ref |sort
156         fi)
157 }
158
159 t-untar () {
160         local tarfile=$1.tar
161         local edittree=$1.edit
162         if test -d "$edittree"; then
163                 cp -a "$edittree"/* .
164         else
165                 tar xf "$tarfile"
166         fi
167 }
168
169 t-worktree () {
170         rm -rf $p
171         t-untar $troot/worktrees/${p}_$1
172 }
173
174 t-select-package () {
175         p=$1
176         dgitrepo=$tmp/git/$p.git
177 }
178
179 t-git () {
180         t-select-package $1
181         v=$2
182         mkdir -p $tmp/git
183         local gs=$troot/git-srcs/${p}_$v.git
184         (set -e; cd $tmp/git; t-untar $gs)
185 }
186
187 t-git-none () {
188         mkdir -p $tmp/git
189         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
190 }
191
192 t-salsa-add-remote () {
193         local d=$tmp/salsa/$p
194         mkdir -p $d
195         (set -e; cd $d; git init --bare)
196         git remote add ${1-origin} $d
197 }
198
199 t-git-merge-base () {
200         git merge-base $1 $2 || test $? = 1
201 }
202
203 t-has-ancestor () {
204         # t-has-ancestor ANCESTOR
205         # (CHILD is implicit, HEAD)
206         local now;      now=`git rev-parse HEAD`
207         local ancestor; ancestor=`git rev-parse $1^{}`
208         local mbase;    mbase=`t-git-merge-base $ancestor $now`
209         if [ x$mbase != x$ancestor ]; then
210                 fail "not ff $ancestor..$now, $mbase != $ancestor"
211         fi
212 }
213
214 t-has-parent-or-is () {
215         # t-has-parent-or-is CHILD PARENT
216         local child=$1
217         local parent=$2
218         local parents
219         parents=$(git show --pretty=format:' %P %H ' "$child")
220         parent=$(git rev-parse "$parent~0")
221         case "$parents" in
222         *" $parent "*)  ;;
223         *)      fail "child $child lacks parent $parent" ;;
224         esac
225 }
226
227 t-prep-newpackage () {
228         t-select-package $1
229         v=$2
230         t-archive-none $p
231         t-git-none
232         t-worktree $v
233         cd $p
234         if ! git show-ref --verify --quiet refs/heads/master; then
235                 git branch -m dgit/sid master
236                 git remote rm dgit
237         fi
238         cd ..
239 }
240
241 t-archive-none () {
242         t-select-package $1
243         t-archive-none-$t_archive_method
244 }
245 t-archive-none-aq () {
246         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
247
248         : >$tmp/aq/suites
249         local jsondelim="["
250
251         local suitespec
252         for suitespec in $suitespecs; do
253                 local suite=${suitespec%%:*}
254                 local sname=${suitespec#*:}
255
256                 >$tmp/aq/package.$suite.$p
257                 t-aq-archive-updated $suite $p
258
259                 >$tmp/aq/package.new.$p
260                 t-aq-archive-updated new $p
261
262                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
263
264                 cat <<END >>$tmp/aq/suites
265 $jsondelim
266    {
267       "archive" : "ftp-master",
268       "codename" : "$suite",
269       "components" : [
270          "main",
271          "contrib",
272          "non-free"
273       ],
274       "name" : "$sname",
275       "dakname" : "$sname"
276 END
277
278                 jsondelim="   },"
279
280         done
281         cat <<END >>$tmp/aq/suites
282     }
283 ]
284 END
285 }
286
287 t-aq-archive-updated () {
288         local suite=$1
289         local p=$2
290         local suitedir=$tmp/aq/dsc_in_suite/$suite
291         mkdir -p $suitedir
292         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
293                 use JSON;
294                 use strict;
295                 our @v;
296                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
297                 push @v, {
298                         "version" => "$1",
299                         "sha256sum" => "$2",
300                         "component" => "$3",
301                         "filename" => "$4",
302                 };
303                 END {
304                         my $json = JSON->new->canonical();
305                         print $json->encode(\@v) or die $!;
306                 }
307         '
308 }
309
310 t-archive-process-incoming () {
311         local suite=$1
312         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
313         t-archive-query "$suite"
314 }
315
316 t-archive-query () {
317         local suite=${1-sid}
318         local dscf=main/${p}_${v}.dsc
319         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
320 }
321 t-archive-query-aq () {
322         local suite=$1
323         local p=$2
324         local v=$3
325         local dscf=$4
326         local sha; sha=`sha256sum <$tmp/mirror/pool/$dscf`
327         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
328         t-aq-archive-updated $suite $p
329 }
330
331 t-archive () {
332         t-archive-none $1
333         v=$2
334         local dscf=${p}_$2.dsc
335         rm -f $tmp/mirror/pool/main/${p}_*
336         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
337         t-archive-query $suite
338         rm -rf $tmp/extract
339         mkdir $tmp/extract
340         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
341 }
342
343 t-git-dir-time-passes () {
344         touch -d 'last year' $dgitrepo
345 }
346
347 t-git-dir-check () {
348         local gitdir=$dgitrepo
349         case "$1" in
350         enoent)
351                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
352                 return
353                 ;;
354         public) wantstat='7[75]5' ;;
355         secret) wantstat='7[70]0' ;;
356         *)      fail "$1 t-git-dir-check ?" ;;
357         esac
358         gotstat=`stat -c%a $gitdir`
359         case "$gotstat" in
360         *$wantstat) return ;;
361         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
362         esac
363 }
364
365 t-expect-fsck-fail () {
366         echo >>$tmp/fsck.expected-errors "$1"
367 }
368
369 t-git-fsck () {
370         local fsckerrs=$(git rev-parse --git-dir)/dgit-test-fsck.errs
371
372         set +e
373         LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
374                 | tee $fsckerrs
375         ps="${PIPESTATUS[*]}"
376         set -e
377
378         local pats
379         if [ -f $tmp/fsck.expected-errors ]; then
380                 pats=(-w -f $tmp/fsck.expected-errors)
381         else
382                 test "$ps" = "0 0"
383         fi
384         pats+=(-e 'notice: HEAD points to an unborn branch')
385         pats+=(-e 'notice: No default references')
386
387         set +e
388         grep -v "${pats[@]}" $fsckerrs
389         rc=$?
390         set -e
391         case $rc in
392         1) ;; # no unexpected errors
393         0) fail "unexpected messages from git-fsck" ;;
394         *) fail "grep of git-fsck failed" ;;
395         esac
396 }
397
398 t-fscks () {
399         (
400         shopt -s nullglob
401         for d in $tmp/*/.git $tmp/git/*.git; do
402                 cd "${d%/.git}"
403                 t-git-fsck
404         done
405         )
406 }
407
408 t-ok () {
409         : '========================================'
410         t-fscks
411         echo ok.
412 }
413
414 t-rm-dput-dropping () {
415         rm -f $tmp/${p}_${v}_*.upload
416 }
417
418 t-dgit () {
419         local dgit=${DGIT_TEST-dgit}
420         pwd >&2
421         : '
422 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
423         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
424  ${dgit_config_debian_alias-"--config-lookup-explode=dgit-distro.debian.alias-canon"} \
425                 ${distro+${distro:+-d}}${distro--dtest-dummy} \
426                 $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
427                 -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $t_dgit_xopts "$@"
428         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
429 '
430 }
431
432 t-dgit-manpage () {
433         local section=$1
434         local page=$2
435         (export LC_ALL=C.UTF-8
436          if [ "$DGIT_TEST_INTREE" ]; then
437                 make -C $DGIT_TEST_INTREE $page.$section.view
438          else
439                 man $section $page
440          fi)
441 }
442
443 t-diff-nogit () {
444         diff --exclude=.git --exclude=.pc -ruN $*
445 }
446
447 t-files-notexist () {
448         local f
449         for f in "$@"; do
450                 if [ -e $f ]; then
451                         fail "$f exists!"
452                 fi
453         done
454 }
455
456 t-cloned-fetched-good () {
457         t-diff-nogit ../extract/$p-${v%-*} .
458         t-clean-on-branch dgit/sid
459         t-refs-same-start
460         t-refs-same \
461                 refs/heads/dgit/sid \
462                 refs/remotes/dgit/dgit/sid
463         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
464 }
465
466 t-output () {
467         printf "%s${1:+\n}" "$1" >$tmp/t.want
468         shift
469         "$@" >$tmp/t.got
470         diff $tmp/t.want $tmp/t.got
471 }
472
473 t-clean-on-branch () {
474         t-output "## $1" git status -b --porcelain
475 }
476
477 t-setup-done () {
478         local savevars=$1
479         local savedirs=$2
480         local importeval=$3
481
482         local import=IMPORT.${0##*/}
483         exec 4>$tmp/$import.new
484
485         local vn
486         for vn in $savevars; do
487                 perl >&4 -I. -MDebian::Dgit -e '
488                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
489                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
490         done
491
492         (set -e; cd $tmp; tar cf $import.tar $savedirs)
493
494         printf >&4 "\n%s\n" "$importeval"
495
496         mv -f $tmp/$import.new $tmp/$import
497 }
498
499 t-setup-import () {
500         local setupname=$1
501
502         local setupsrc
503         local lock
504         if [ "x$tmpbase" = x ]; then
505                 # ADTTMP was set on entry to tests/lib, so we
506                 # are not sharing tmp area between tests
507                 setupsrc="$tmp"
508                 lock="$tmp/.dummy.lock"
509         else
510                 setupsrc="$tmpbase/$setupname"
511                 lock="$setupsrc.lock"
512         fi
513
514         local simport="$setupsrc/IMPORT.$setupname"
515
516         if ! [ -e "$simport" ]; then
517                 with-lock-ex -w "$lock" \
518                 xargs -0 -a $tmp/.save-env \
519                 bash -xec '
520                         cd "$1"; shift
521                         setupname="$1"; shift
522                         simport="$1"; shift
523                         if [ -e "$simport" ]; then exit 0; fi
524                         env - "$@" \
525                         "tests/setup/$setupname"
526                 ' x "$root" "$setupname" "$simport"
527         fi
528
529         if [ "x$setupsrc" != "x$tmp" ]; then
530                 (set -e; cd $tmp; tar xf "$simport.tar")
531         fi
532
533         . "$simport"
534 }
535
536 t-git-get-ref-exact () {
537         local ref=$1
538         # does not dereference, unlike t-git-get-ref
539         case "$ref" in
540         refs/*) ;;
541         *) fail "t-git-get-ref-exact bad $ref" ;;
542         esac
543         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
544 }
545
546 t-git-get-ref () {
547         local ref=$1
548         case "$ref" in
549         refs/*) ;;
550         *) fail "t-git-get-ref bad $ref" ;;
551         esac
552         (git show-ref -d $1 || test $? = 1) | perl -ne '
553                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
554                 END { print "$x\n" if length $x; }
555         '
556 }
557
558 t-ref-same-exact () {
559         local name="$1"
560         local val; val=`t-git-get-ref-exact $name`
561         t-ref-same-val "$name" $val
562 }
563
564 t-ref-same () {
565         local name="$1"
566         local val; val=`t-git-get-ref $name`
567         t-ref-same-val "$name" $val
568 }
569
570 t-ref-head () {
571         local val; val=`git rev-parse HEAD`
572         t-ref-same-val HEAD $val
573 }
574
575 t-ref-same-val () {
576         local name="$1"
577         local val=$2
578         case "${t_ref_val-unset}" in
579         unset)          ;;
580         "$val")         ;;
581         *)              fail "ref varies: ($name)\
582  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
583         esac
584         t_ref_val="$val"
585         t_ref_names+=("$name")
586 }
587
588 t-refs-same-start () {
589         unset t_ref_val
590         t_ref_names=()
591 }
592
593 t-refs-same () {
594         local g
595         for g in $*; do
596                 t-ref-same $g
597         done
598 }
599
600 t-refs-notexist () {
601         local val
602         for g in $*; do
603                 val=`t-git-get-ref $g`
604                 if [ "x$val" != x ]; then
605                         fail "ref $g unexpectedly exists ($val)"
606                 fi
607         done
608 }
609
610 t-v-tag () {
611         echo refs/tags/$tagpfx/${v//\~/_}
612 }
613
614 t-format-ref () {
615         git log -n1 --pretty=format:"$1" "$2"
616 }
617
618 t-sametree-parent () {
619         local ref=$1
620         local parent
621         local ctree; ctree=$(t-format-ref '%T' "$ref")
622         while :; do
623                 local psame=''
624                 for parent in $(t-format-ref '%P' "$ref"); do
625                         local ptree; ptree=$(t-format-ref '%T' "$parent")
626                         if [ "x$ptree" = "x$ctree" ]; then
627                                 psame+=" $parent"
628                         fi
629                 done
630                 case "$psame" in ""|" * *") break ;; esac
631                 ref="${psame# }"
632         done
633         echo "$ref"
634 }
635
636 t-check-pushed-master () {
637         local master; master=`t-git-get-ref refs/heads/master`
638         if [ x$master = x$t_ref_val ]; then return; fi
639         if [ x$master = x ]; then fail "failed to push master"; fi
640         # didn't update master, it must be not FF
641         local mbase; mbase=`t-git-merge-base $master $t_ref_val`
642         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
643 }
644
645 t-push-was-source-only () {
646         local f
647         t-files-notexist $tmp/incoming/${p}_${v}_*.deb \
648                          $tmp/incoming/${p}_${v}_*.udeb
649         # we permit _source.buildinfo files; see test_changes_source_only()
650         for f in $tmp/incoming/${p}_${v}_*.buildinfo; do
651             if [ -e $f ]; then
652                 case "$f" in
653                     *_source.buildinfo) ;;
654                     *) fail "non-source-only file $f exists!" ;;
655                 esac
656             fi
657         done
658 }
659
660 t-pushed-good () {
661         local branch=$1
662         local suite=${2:-sid}
663         t-refs-same \
664                 refs/heads/$branch
665         t-pushed-good-core
666 }
667         
668 t-pushed-good-core () {
669         t-ref-dsc-dgit
670         t-refs-same \
671                 `t-v-tag` \
672                 refs/remotes/dgit/dgit/$suite
673         t-refs-notexist \
674                 refs/heads/dgit/unstable \
675                 refs/remotes/dgit/dgit/unstable
676         (set -e; cd $dgitrepo
677          t-refs-same \
678                 refs/dgit/$suite \
679                 `t-v-tag`
680          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
681          t-refs-notexist \
682                 refs/dgit/unstable
683         )
684         git verify-tag `t-v-tag`
685 }
686
687 t-splitbrain-pushed-good--unpack () {
688         cd $tmp
689         rm -rf t-unpack
690         mkdir t-unpack
691         cd t-unpack
692         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
693         ln -s $tmp/incoming/*.orig*.tar* . ||:
694         ln -s $incoming_dsc .
695         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
696         dpkg-source "$@" -x *.dsc
697         cd */.
698         git init
699         git fetch ../../$p "refs/tags/*:refs/tags/*"
700 }
701
702 t-splitbrain-pushed-good--checkprep () {
703         git add -Af .
704         git rm --cached -r --ignore-unmatch .pc
705 }
706
707 t-splitbrain-pushed-good--checkdiff () {
708         local tag=$1
709         t-splitbrain-pushed-good--checkprep
710         t-output "" git diff --stat --cached $tag
711 }
712
713 t-splitbrain-pushed-good-start () {
714         dep14tag=refs/tags/test-dummy/${v//\~/_}
715         dgittag=$(t-v-tag)
716         t-output "" git status --porcelain
717         t-ref-head
718         t-refs-same $dep14tag
719         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
720         git merge-base --is-ancestor $dep14tag $dgittag
721
722         t-refs-same-start
723         t-ref-same refs/heads/split.p
724         case "$(t-git-get-ref refs/heads/split.b)" in
725         "$t_ref_val") ;;
726         "$(git rev-parse refs/heads/split.p^0)") ;;
727         "$(git rev-parse refs/heads/split.p^1)") ;;
728         *) fail 'bad b/p' ;;
729         esac
730         t-pushed-good-core
731
732         t-incoming-dsc
733
734         t-splitbrain-pushed-good--unpack
735         t-splitbrain-pushed-good--checkdiff $dgittag
736 }
737 t-splitbrain-pushed-good-end-made-dep14 () {
738         t-splitbrain-pushed-good--checkdiff $dep14tag
739         cd $tmp/$p
740 }
741
742 t-splitbrain-rm-gitignore-patch () {
743         perl -i -pe '
744                 next unless $_ eq "auto-gitignore\n";
745                 die if $counter++;
746                 chomp;
747                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
748                 $_ = "";
749         ' debian/patches/series
750 }
751
752 t-gbp-pushed-good () {
753         local suite=${1:-sid}
754         t-splitbrain-pushed-good-start
755
756         # Right, now we want to check that the maintainer tree and
757         # the dgit tree differ in exactly the ways we expect.  We
758         # achieve this by trying to reconstruct the maintainer tree
759         # from the dgit tree.
760
761         # So, unpack it withut the patches applied
762         t-splitbrain-pushed-good--unpack --skip-patches
763
764         # dgit might have added a .gitignore patch, which we need to
765         # drop and remove
766         t-splitbrain-rm-gitignore-patch
767
768         # Now the result should differ only in non-debian/ .gitignores
769         t-splitbrain-pushed-good--checkprep
770         git diff --cached --name-only $dep14tag >../changed
771         perl -ne '
772                 next if !m#^debian/# && m#(^|/)\.gitignore#;
773                 die "$_ mismatch";
774         ' <../changed
775
776         # If we actually apply the gitignore patch by hand, it
777         # should be perfect:
778         if [ -f ../t-auto-gitignore ]; then
779                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
780         fi
781
782         t-splitbrain-pushed-good-end-made-dep14
783 }
784
785 t-unapplied-pushed-good () {
786         t-splitbrain-pushed-good-start
787         t-splitbrain-pushed-good--unpack --skip-patches
788         t-splitbrain-pushed-good-end-made-dep14
789 }
790
791 t-dpm-pushed-good () {
792         t-splitbrain-pushed-good-start
793         t-splitbrain-pushed-good--unpack
794         t-splitbrain-rm-gitignore-patch
795         t-splitbrain-pushed-good-end-made-dep14
796 }
797
798 t-commit-build-push-expect-log () {
799         local msg=$1
800         local mpat=$2
801         t-commit "$msg"
802         t-dgit build
803         LC_MESSAGES=C \
804         t-dgit push --new 2>&1 |tee $tmp/push.log
805         t-grep-mpat "$mpat" $tmp/push.log
806 }
807
808 t-822-field () {
809         local file=$1
810         local field=$2
811         perl -e '
812                 use Dpkg::Control::Hash;
813                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
814                 $h->parse(\*STDIN,"'"$file"'");
815                 my $val = $h->{"'$field'"},"\n";
816                 die "'"$file $field"'" unless defined $val;
817                 print $val,"\n";
818         ' <$file
819 }
820
821 t-defdistro () {
822         export DGIT_TEST_DISTRO=''
823         distro=''
824         t-git-config dgit-suite.unstable.distro test-dummy
825 }
826
827 t-stunt-envvar () {
828         local var=$1
829         local tstunt=$2
830         eval '
831                 case "$'$var'" in
832                 "$tstunt:"*)    ;;
833                 *":$tstunt:"*)  ;;
834                 "")             '$var'="$tstunt" ;;
835                 *)              '$var'="$tstunt:$'$var'" ;;
836                 esac
837                 export '$var'
838         '
839 }
840
841 t-tstunt--save-real () {
842         local f="$1"
843         case "$f" in
844         */*) return ;;
845         esac
846
847         local rc
848         local real
849         set +e
850         real=$(
851                 p=":$PATH:"
852                 p="${p/:"$tmp/tstunt":/:}"
853                 p="${p%:}"
854                 p="${p#:}"
855                 PATH="$p"
856                 type -p "$f"
857         )
858         rc=$?
859         set -e
860
861         case $rc in
862         1)      return ;;
863         0)      ;;
864         *)      fail "did not find $f on PATH $PATH" ;;
865         esac
866
867         local varname=${f//[^_0-9a-zA-Z]/_}
868         varname=DGIT_TEST_REAL_${varname^^}
869
870         eval "
871                 : \${$varname:=\$real}
872                 export $varname
873         "
874 }
875
876 t-tstunt () {
877         local tstunt=$tmp/tstunt
878         t-stunt-envvar PATH $tstunt
879         t-stunt-envvar PERLLIB $tstunt
880         local f
881         for f in "$@"; do
882                 t-tstunt--save-real $f
883                 f="./$f"
884                 local d="$tstunt/${f%/*}"
885                 mkdir -p $d
886                 ln -sf "$troot/tstunt/$f" "$d"/.
887         done
888 }
889
890 t-tstunt-parsechangelog () {
891         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
892 }
893
894 t-tstunt-lintian () {
895         t-tstunt lintian
896 }
897
898 t-tstunt-debuild () {
899         t-tstunt debuild
900 }
901
902 t-incoming-dsc () {
903         local dsc=${p}_${v}.dsc
904         incoming_dsc=$tmp/incoming/$dsc
905 }
906
907 t-ref-dsc-dgit () {
908         t-incoming-dsc
909         local val; val=`t-822-field $incoming_dsc Dgit`
910         val=$( perl -e '
911                 $_=shift @ARGV;
912                 die "Dgit $_ ?" unless m/^\w+\b/;
913                 print $&,"\n" or die $!;
914         ' "$val")
915         t-ref-same-val $incoming_dsc "$val"
916 }
917
918 t-apply-diff () {
919         local v1=$1
920         local v2=$2
921         (cd $troot/pkg-srcs;
922          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
923          | patch -p1 -u
924 }
925
926 t-gbp-unapplied-pq2qc () {
927         # does `gbp pq export'
928         # commits the resulting debian/patches on  qc/BRANCH
929         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
930         # qc/BRANCH is not fast-forwarding
931
932         gbp pq export
933
934         branch=`git symbolic-ref HEAD`
935         branch=${branch#refs/heads/}
936
937         case "$branch" in
938         */*) fail "unexpected branch $branch" ;;
939         esac
940
941         git branch -f qc/$branch
942         git checkout qc/$branch
943         git add debian/patches
944         git commit -m 'Commit patch queue'
945 }
946
947 t-git-pseudo-merge () {
948         # like   git merge -s ours
949         if [ ! "$git_pseuomerge_opts" ]; then
950                 if git merge --help \
951                  | grep -q allow-unrelated-histories; then
952                         git_pseuomerge_opts='--allow-unrelated-histories'
953                 fi
954                 git_pseuomerge_opts+=' -s ours'
955         fi
956         git merge $git_pseuomerge_opts "$@"
957 }
958
959 t-gbp-example-prep-no-ff () {
960         t-tstunt-parsechangelog
961         t-archive example 1.0-1
962         t-git-none
963         t-worktree 1.0
964
965         cd example
966
967         t-dgit fetch
968
969         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
970         gbp pq rebase
971
972         echo '/* some comment */' >>src.c
973         git add src.c
974         git commit -m 'Add a comment to an upstream file'
975
976         t-gbp-unapplied-pq2qc
977
978         t-commit 'some updates' 1.0-2
979 }
980
981 t-gbp-example-prep () {
982         t-gbp-example-prep-no-ff
983
984         t-git-pseudo-merge \
985                 -m 'Pseudo-merge to make descendant of archive' \
986                 remotes/dgit/dgit/sid
987 }
988
989 t-make-badcommit () {
990         badcommit=$(
991                 git cat-file commit HEAD | \
992                 perl -pe 's/^committer /commiter /' | \
993                 git hash-object -w -t commit --stdin
994         )
995         t-expect-fsck-fail $badcommit
996 }
997
998 t-commit () {
999         local msg=$1
1000         v=${2:-${majorv:-1}.$revision}
1001         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
1002         git add debian/changelog
1003         debcommit
1004         revision=$(( ${revision-0} + 1 ))
1005 }
1006
1007 t-dch-commit () {
1008         dch "$@"
1009         git commit -m "dch $*" debian/changelog
1010 }
1011
1012 t-git-config () {
1013         git config --global "$@"
1014 }
1015
1016 t-drs () {
1017  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
1018  t-git-config dgit-distro.test-dummy.git-check true
1019  t-git-config dgit-distro.test-dummy.git-create true
1020  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
1021         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
1022         cp $troot/suites $tmp/.
1023         cp $troot/suites $tmp/suites-master
1024
1025         export t_check_pushed_master=t-check-pushed-master
1026
1027         drs_dispatch=$tmp/distro=test-dummy
1028         mkdir $drs_dispatch
1029
1030         if [ "x$DGIT_TEST_INTREE" != x ]; then
1031                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
1032         fi
1033
1034         ln -sf $tmp/git $drs_dispatch/repos
1035         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
1036         mkdir -p $drs_dispatch/keyrings
1037         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
1038         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
1039         ln -sf /bin/true $drs_dispatch/policy-hook
1040 }
1041
1042 t-newtag () {
1043  export tagpfx=archive/test-dummy
1044  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
1045 }
1046 t-oldtag () {
1047  export tagpfx=test-dummy
1048  t-git-config dgit-distro.test-dummy.dgit-tag-format old
1049 }
1050
1051 t-dsd () {
1052         t-drs
1053  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
1054  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
1055  t-git-config dgit-distro.test-dummy.git-create true
1056  t-git-config dgit-distro.test-dummy.git-url \
1057                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
1058
1059  t-git-config dgit-distro.test-dummy.diverts.drs /drs
1060  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
1061  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
1062  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
1063  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
1064
1065         echo 'no-such-package* drs' >$drs_dispatch/diverts
1066 }
1067
1068 t-policy-admin () {
1069         : '(((((((((((((((((((((((((((((((((((((((('
1070         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
1071         : '))))))))))))))))))))))))))))))))))))))))'
1072 }
1073
1074 t-policy-nonexist () {
1075         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
1076 }
1077
1078 t-make-hook-link () {
1079         local hook=$1 # in infra/
1080         local linkpath=$2
1081         hook=${DGIT_INFRA_PFX}$hook
1082         case $hook in
1083         */*)    ;;
1084         *)      hook=`type -P $hook` ;;
1085         esac
1086         ln -sf "$hook" $linkpath
1087 }
1088
1089 t-policy () {
1090         local policyhook=$1
1091         t-make-hook-link $policyhook $drs_dispatch/policy-hook
1092 }
1093
1094 t-debpolicy () {
1095         t-dsd
1096         t-policy dgit-repos-policy-debian
1097
1098         mkdir $tmp/git
1099         t-policy-admin create-db
1100 }
1101
1102 t-policy-periodic () {
1103         : '(((((((((((((((((((((((((((((((((((((((('
1104         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
1105                 test-dummy $drs_dispatch '' --cron
1106         : '))))))))))))))))))))))))))))))))))))))))'
1107 }
1108
1109 t-restrict () {
1110         local restriction=$1
1111         (cd $root; t-restriction-$restriction >&2)
1112 }
1113
1114 t-dependencies () {
1115         : "Hopefully installed: $*"
1116 }
1117
1118 t-chain-test () {
1119         local ct=$1
1120         local d=${0%/*}
1121         cd $root
1122         export DGIT_TEST_TESTNAME="$testname"
1123         export DGIT_TEST_TMPBASE="$tmpbase"
1124         export ADTTMP=$tmp
1125         exec "$d/$ct"
1126 }       
1127
1128 t-alt-test () {
1129         local t=${0##*/}
1130         t-${t%%-*}
1131         t-chain-test "${t#*-}"
1132 }
1133
1134 t-git-config dgit.default.old-dsc-distro test-dummy
1135
1136 case "$0" in
1137 */gnupg) ;;
1138 *)      t-setup-import gnupg    ;;
1139 esac